import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import VisaMetarialsList from '@/types/table/visaMetarialsList';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface VisaMetarialsListData extends VisaMetarialsList {
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class VisaMetarialsListController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<VisaMetarialsListData>>(API_CONTEXT + '/app/visaMetarialsList/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<VisaMetarialsListData>(API_CONTEXT + '/app/visaMetarialsList/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/visaMetarialsList/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/visaMetarialsList/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/visaMetarialsList/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/visaMetarialsList/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/visaMetarialsList/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/visaMetarialsList/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/visaMetarialsList/deleteBatch', params, httpOptions);
  }
}
